/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.reactivex.ext.cluster.infinispan;

import java.util.Map;
import io.reactivex.Observable;
import io.reactivex.Flowable;
import io.reactivex.Single;
import io.reactivex.Completable;
import io.reactivex.Maybe;
import io.vertx.reactivex.core.shareddata.AsyncMap;
import io.vertx.reactivex.core.streams.ReadStream;

/**
 * Extensions to the generic .
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.ext.cluster.infinispan.InfinispanAsyncMap original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.reactivex.RxGen(io.vertx.ext.cluster.infinispan.InfinispanAsyncMap.class)
public class InfinispanAsyncMap<K,V> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    InfinispanAsyncMap that = (InfinispanAsyncMap) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final io.vertx.lang.reactivex.TypeArg<InfinispanAsyncMap> __TYPE_ARG = new io.vertx.lang.reactivex.TypeArg<>(
    obj -> new InfinispanAsyncMap((io.vertx.ext.cluster.infinispan.InfinispanAsyncMap) obj),
    InfinispanAsyncMap::getDelegate
  );

  private final io.vertx.ext.cluster.infinispan.InfinispanAsyncMap delegate;
  public final io.vertx.lang.reactivex.TypeArg<K> __typeArg_0;
  public final io.vertx.lang.reactivex.TypeArg<V> __typeArg_1;
  
  public InfinispanAsyncMap(io.vertx.ext.cluster.infinispan.InfinispanAsyncMap delegate) {
    this.delegate = delegate;
    this.__typeArg_0 = io.vertx.lang.reactivex.TypeArg.unknown();
    this.__typeArg_1 = io.vertx.lang.reactivex.TypeArg.unknown();
  }

  public InfinispanAsyncMap(io.vertx.ext.cluster.infinispan.InfinispanAsyncMap delegate, io.vertx.lang.reactivex.TypeArg<K> typeArg_0, io.vertx.lang.reactivex.TypeArg<V> typeArg_1) {
    this.delegate = delegate;
    this.__typeArg_0 = typeArg_0;
    this.__typeArg_1 = typeArg_1;
  }

  public io.vertx.ext.cluster.infinispan.InfinispanAsyncMap getDelegate() {
    return delegate;
  }

  /**
   * Unwraps a generic  to an {@link io.vertx.reactivex.ext.cluster.infinispan.InfinispanAsyncMap}.
   * @param asyncMap 
   * @return 
   */
  public static <K, V> InfinispanAsyncMap<K,V> unwrap(AsyncMap asyncMap) { 
    InfinispanAsyncMap<K,V> ret = InfinispanAsyncMap.newInstance(io.vertx.ext.cluster.infinispan.InfinispanAsyncMap.unwrap(asyncMap.getDelegate()), io.vertx.lang.reactivex.TypeArg.unknown(), io.vertx.lang.reactivex.TypeArg.unknown());
    return ret;
  }

  /**
   * Get the keys of the map as a .
   * <p>
   * The stream will be automatically closed if it fails or ends.
   * Otherwise you must set a null  after usage to avoid leaking resources.
   * @return a stream of map keys
   */
  public ReadStream<K> keyStream() { 
    ReadStream<K> ret = ReadStream.newInstance(delegate.keyStream(), __typeArg_0);
    return ret;
  }

  /**
   * Get the values of the map as a .
   * <p>
   * The stream will be automatically closed if it fails or ends.
   * Otherwise you must set a null  after usage to avoid leaking resources.
   * @return a stream of map values
   */
  public ReadStream<V> valueStream() { 
    ReadStream<V> ret = ReadStream.newInstance(delegate.valueStream(), __typeArg_1);
    return ret;
  }


  public static <K,V>InfinispanAsyncMap<K,V> newInstance(io.vertx.ext.cluster.infinispan.InfinispanAsyncMap arg) {
    return arg != null ? new InfinispanAsyncMap<K,V>(arg) : null;
  }

  public static <K,V>InfinispanAsyncMap<K,V> newInstance(io.vertx.ext.cluster.infinispan.InfinispanAsyncMap arg, io.vertx.lang.reactivex.TypeArg<K> __typeArg_K, io.vertx.lang.reactivex.TypeArg<V> __typeArg_V) {
    return arg != null ? new InfinispanAsyncMap<K,V>(arg, __typeArg_K, __typeArg_V) : null;
  }
}
